﻿* Encoding: UTF-8.
*Categorical - Binary recodings
*SPSS macros by Kirill Orlov
*kior@comtv.ru, ttnphns@gmail.com
*https://www.spsstools.net/en/KO-spssmacros
*All rights reserved.

*/*!KO_CATBIN*/vers4***************************************************************************.
define !KO_catbin(vars= !charend('/') /values= !charend('/') /sqcond= !charend('/') /separ= !charend('/') /ending= !charend('/')
                 /label= !charend('/') /macro= !charend('/'))
exec.
-echo ''.
-echo '**** CATEGORICAL INTO DUMMY ****'.
!let !ok= 1 !let !sep= !unquote(!separ) !let !novars= 1
!if (!index(!values,'-')>0) !then !let !ok= 0
-echo ''.
-echo '>ERROR. VALUES cannot contain negative values.'.
!else !if (!index(!values,' EXCEPT')>0 !and !upcase(!head(!tail(!values)))<>'TO') !then !let !ok= 0
-echo ''.
-echo '>ERROR. VALUES has keyword EXCEPT, but TO on position two is missing.'.
!else !if (!index(!sep,' ')>0) !then !let !ok= 0
-echo ''.
-echo '>ERROR. SEPAR cannot contain a blank.'.
!else
 !if (!upcase(!head(!tail(!values)))='TO') !then !let !vals= !null
  !if (!head(!tail(!tail(!tail(!values))))='EXCEPT') !then !let !except= !tail(!tail(!tail(!tail(!values)))) !ifend
  !do !i= !head(!values) !to !head(!tail(!tail(!values)))
   !if (!index(!conc(!except,' '),!conc(' ',!i,' '))=0) !then !let !vals= !conc(!vals,' ',!i) !ifend
  !doend
 !else !let !vals= !values
  !do !w !in (!vals)
   !if (!index('.0123456789',!substr(!w,1,1))=0) !then !let !novars= 0 !break !ifend
  !doend
 !ifend
 !if (!tail(!vals)=!null) !then !let !ok= 0
- echo '>ERROR. VALUES must make up at least two values.'.
 !ifend
!ifend !ifend !ifend
!if (!ok) !then
 !if (!label='YES' !and !not !novars) !then
- echo ''.
- echo '>WARNING. LABEL=YES, but there are variable names in VALUES.'.
- echo '>!KO_CATBIN will change the specification to LABEL=NO.'.
 !ifend
 !let !prevar= !null
 !do !var !in (!vars) !let !cnt= !null !let !bvars= !null
  !do !val !in (!vals) !let !cnt= !conc(!cnt,' ')
   !if (!ending='INDEX') !then !let !bvars= !conc(!bvars,' ',!var,!sep,!len(!cnt))
   !else !let !bvars= !conc(!bvars,' ',!var,!sep,!val)
   !ifend
  !doend
- numer !bvars (f1).
- var lev !bvars (ord).
- do rep bvar= !bvars /val= !vals !if (!sqcond<>!null) !then /#val= #1 to !conc(#,!len(!cnt)) !ifend.
-  if not miss(!var) bvar= 0.
   !if (!sqcond<>!null) !then
    !if (!prevar=!null) !then
-    comp #val= 0.
    !else
     !if (!len(!sqcond)=2) !then
-     do if !var !sqcond !prevar.
     !else !if (!sqcond='FIRST') !then
-     do if not #val.
     !else !if (!sqcond='FEQ') !then
-     do if not #val or !var !substr(!sqcond,2) !prevar.
     !ifend !ifend !ifend
    !ifend
   !ifend
-      comp bvar= !var=val.
     !if (!not !novars) !then
-      if not miss(!var) bvar= bvar*(not miss(val)).
     !ifend
   !if (!sqcond<>!null) !then
    !if (!prevar<>!null) !then
-     end if.
    !ifend
    !if (!sqcond='FIRST' !or !sqcond='FEQ') !then
-    if !var=val #val= 1.
    !ifend
   !ifend
- end rep.
  !let !prevar= !var
 !doend
-exec.
 !if (!label='YES' !and !novars) !then !let !bylabs= 1 !else !let !bylabs= 0 !ifend
 !let !qvals= !null !let !vals2= !null
 !do !w !in (!vals) !let !qvals= !conc(!qvals,' ',!quote(!w)) !doend
 !if (!ending='INDEX') !then !let !cnt= !null
  !do !w !in (!vals) !let !cnt= !conc(!cnt,' ') !let !vals2= !conc(!vals2,' ',!quote(!len(!cnt))) !doend
 !else
  !let !vals2= !qvals
 !ifend
 !if (!bylabs) !then !let !cnt= !null
  !do !var !in (!vars) !let !cnt= !conc(!cnt,' ')
-  apply dict from= * /source var= !var /target var= !conc('val$$$$$.',!len(!cnt)) /newvar /varinfo vallab.
  !doend
 !ifend
-string val$$$$$._$ (a180).
-do if $casenum=1.
- write outfile= 'temp_KO_catbin_1.sps' /'var lab'.
  !let !cnt= !null
  !do !var !in (!vars) !let !cnt= !conc(!cnt,' ') !let !var#= !conc('val$$$$$.',!len(!cnt))
-  do rep val= !vals /val2= !vals2 /qval= !qvals.
    !if (!bylabs) !then
-    comp !var#= val.
-    comp val$$$$$._$= replace(valuelab(!var#),"'","`").
-    comp val$$$$$._$= conc(" ",!quote(!var),!quote(!sep),val2," '",rtrim(val$$$$$._$),"'").
    !else
-    comp val$$$$$._$= conc(" ",!quote(!var),!quote(!sep),val2," '",qval,"'").
    !ifend
-   write outfile= 'temp_KO_catbin_1.sps' /val$$$$$._$.
-  end rep.
  !doend
-end if.
-exec.
-insert file= 'temp_KO_catbin_1.sps' syntax= batch.
-delete vari !if (!bylabs) !then val$$$$$.1 to !var# !ifend val$$$$$._$.
-erase file 'temp_KO_catbin_1.sps'.
 !if (!macro<>'NONE' !and !macro<>!null) !then
  !let !sep2= !sep
  !if (!sep2<>!null) !then !let !lensp2= !len(!sep2)
   !if (!index('._',!substr(!sep2,!lensp2))>0) !then !let !sep2= !head(!substr(!conc(' ',!sep2),1,!lensp2))
-   echo ''.
-   echo '>WARNING. SEPAR ends with "." or "_". When MACRO<>NONE, this'.
-   echo '>tail symbol is dropped from the macro name (name of a set of dummies).'.
   !ifend
  !ifend
  !if (!sep2<>!null) !then !let !lensp2= !len(!sep2)
   !if (!index('._',!substr(!sep2,!lensp2))>0) !then !let !sep2= !head(!substr(!conc(' ',!sep2),1,!lensp2)) !ifend
  !ifend
  !if (!macro='BUTLAST') !then
   !do !val !in (!vals) !let !lstval= !val !doend
  !ifend
- echo ''.
- echo '!KO_CATBIN has created the following sets of dummy variables as macros:'.
  !if (!macro='BUTFIRST') !then
-  echo '(the first dummy omitted from each set)'.
  !else !if (!macro='BUTLAST') !then
-  echo '(the last dummy omitted from each set)'.
  !ifend !ifend
  !do !var !in (!vars) !let !cnt= !null
-     echo ''.
-     echo !quote(!conc('Macro !',!var,!sep2)).
   !do !val !in (!vals) !let !cnt= !conc(!cnt,' ')
    !if (!ending='INDEX') !then !let !bvar= !conc(!var,!sep,!len(!cnt)) !else !let !bvar= !conc(!var,!sep,!val) !ifend
     !if (!macro='ALL' !or (!macro='BUTFIRST' !and !val<>!head(!vals)) !or (!macro='BUTLAST' !and !val<>!lstval)) !then
-     echo !quote(!conc(' ',!bvar)).
     !ifend
   !doend
  !doend
- do if $casenum=1.
-  write outfile= 'temp_KO_catbin_2.sps'
   !do !var !in (!vars) !let !cnt= !null
       /'define ' !quote(!conc('!',!var,!sep2)) '()'
    !do !val !in (!vals) !let !cnt= !conc(!cnt,' ')
     !if (!ending='INDEX') !then !let !bvar= !conc(!var,!sep,!len(!cnt)) !else !let !bvar= !conc(!var,!sep,!val) !ifend
      !if (!macro='ALL' !or (!macro='BUTFIRST' !and !val<>!head(!vals)) !or (!macro='BUTLAST' !and !val<>!lstval)) !then
       /' ' !quote(!bvar)
      !ifend
    !doend
       /'!enddefine.'
   !doend .
- end if.
- exec.
- insert file= 'temp_KO_catbin_2.sps' syntax= batch.
 !ifend
!else
-echo '>!KO_CATBIN is not executed.'.
!ifend
!enddefine.

*/*!KO_ACATBIN*/vers1***************************************************************************.
define !KO_acatbin(vars= !charend('/') /sort= !charend('/') /separ= !charend('/') /ending= !charend('/') /label= !charend('/')
                  /macro= !charend('/') /print= !charend('/'))
exec.
-echo ''.
-echo '**** CATEGORICAL INTO DUMMY (AUTO, !KO_ACATBIN) ****'.
!let !sep= !unquote(!separ)
!if (!index(!sep,' ')>0) !then
-echo ''.
-echo '>ERROR. SEPAR cannot contain a blank.'.
-echo '>!KO_ACATBIN is not executed.'.
!else
 !if (!macro<>'NONE' !and !macro<>!null) !then
  !let !sep2= !sep
  !if (!sep2<>!null) !then !let !lensp2= !len(!sep2)
   !if (!index('._',!substr(!sep2,!lensp2))>0) !then !let !sep2= !head(!substr(!conc(' ',!sep2),1,!lensp2))
-   echo ''.
-   echo '>WARNING. SEPAR ends with "." or "_". When MACRO<>NONE, this'.
-   echo '>tail symbol is dropped from the macro name (name of a set of dummies).'.
   !ifend
  !ifend
  !if (!sep2<>!null) !then !let !lensp2= !len(!sep2)
   !if (!index('._',!substr(!sep2,!lensp2))>0) !then !let !sep2= !head(!substr(!conc(' ',!sep2),1,!lensp2)) !ifend
  !ifend
 !ifend
-set mxloops 1E9.
-filter off.
-use all.
-split file off.
-weight off.
 !do !var !in (!vars)
- dataset decl dummy$$$$$._ window= hidden.
- temp.
- comp !var= trunc(!var).
- matrix.
- get var /var= !var /miss= -999.
  !if (!ending<>'INDEX') !then
-  comp ending= 1.
-  do if any(var<0 and var<>-999).
-   print /title !quote(!conc('>WARNING. Variable ',!var,' contains negative values.')).
-   print /title '>!KO_ACATBIN will change specification ENDING=VALUE to ENDING=INDEX' /space= 0.
-   print /title '>for this variable.' /space= 0.
-   comp ending= 0.
-  end if.
  !else
-  comp ending= 0.
  !ifend
- comp bin= design({-999;var}).
- comp binm= bin(2:nrow(bin),1).
- comp bin= bin(2:nrow(bin),2:ncol(bin)).
- comp freq= csum(bin).
- comp vals= var*make(1,ncol(bin),1)&*bin.
- comp vals= cmax(vals)+cmin(vals).
  !if (!sort<>'NO') !then
-  comp grd= grade(vals).
-  comp bin(:,grd)= bin.
-  comp freq(grd)= freq.
-  comp vals(grd)= vals.
-  release grd.
  !ifend
- comp freq= t(freq).
- comp vals= t(vals).
- comp nmiss= msum(binm).
- release var.
  !if (!print='YES') !then
-  print {vals,freq} /title !quote(!conc('Frequencies in variable ',!var,':')) /clab= 'Value' 'Count'.
-  print (nrow(bin)-nmiss) /title 'Valid N:' /space= 0.
  !ifend
- do if nrow(vals)>1.
-  do if nmiss.
-   comp vec= make(1,ncol(bin),-999).
-   loop i= 1 to nrow(bin).
-    do if binm(i).
-     comp bin(i,:)= vec.
-    end if.
-   end loop.
-  end if.
-  do if ending.
-   comp ends= vals.
-  else.
-   comp ends= t(1:nrow(vals)).
-  end if.
-  do if nrow(bin)>nrow(vals).
-   comp vals= {vals;make(nrow(bin)-nrow(vals),1,-999)}.
-   comp ends= {ends;make(nrow(bin)-nrow(ends),1,-999)}.
-  end if.
-  save {vals,ends,make(nrow(bin),1,ncol(bin)),bin} /out= dummy$$$$$._
     /vari= val$$$$$._ end$$$$$._ nbn$$$$$._ col$$$$$1 to col$$$$$10000.
- else.
-  print /title !quote(!conc('>ERROR. Variable ',!var,' contains only one valid value.')).
-  print /title '>!KO_ACATBIN will not create dummy variables from it, and error messages will follow.' /space= 0.
- end if.
- end matrix.
- match files /file= * /file= dummy$$$$$._.
- comp lstvar#$#$._= 0.
- recode col$$$$$1 to lstvar#$#$._ (-999=sysmis).
- format col$$$$$1 to lstvar#$#$._ (f1).
- var lev col$$$$$1 to lstvar#$#$._ (ord).
- string end$$$$$._$ case#$#$._$ (a8).
- comp end$$$$$._$= ltrim(string(end$$$$$._,f8)).
- comp case#$#$._$= ltrim(string($casenum,f8)).
  !if (!label='YES') !then
-  apply dict from= * /source var= !var /target var= val$$$$$._ /varinfo vallab.
-  string val$$$$$._$ (a123).
-  comp val$$$$$._$= replace(valuelab(val$$$$$._),"'","`").
-  comp val$$$$$._$= conc(" '",rtrim(val$$$$$._$),"'").
  !else
-  string val$$$$$._$ (a10).
-  comp val$$$$$._$= conc("'",rtrim(ltrim(string(val$$$$$._,f8))),"'").
  !ifend
- do if $casenum=1.
-  write outfile= 'temp_KO_acatbin_1.sps'
       /'rename vari'.
- end if.
- do if val$$$$$._<>-999.
-  write outfile= 'temp_KO_acatbin_1.sps'
       /' (col$$$$$' case#$#$._$ '=' !quote(!conc(!var,!sep)) end$$$$$._$ ')'.
- end if.
- do if $casenum=1.
-  write outfile= 'temp_KO_acatbin_2.sps'
       /'var lab'.
- end if.
- do if val$$$$$._<>-999.
-  write outfile= 'temp_KO_acatbin_2.sps'
       /' ' !quote(!conc(!var,!sep)) end$$$$$._$ val$$$$$._$.
- end if.
  !if (!macro<>'NONE' !and !macro<>!null) !then
-  do if $casenum=1.
-   print /'!KO_ACATBIN has created the set of dummy variables as macro: ' !quote(!conc('!',!var,!sep2))
    !if (!macro='BUTFIRST') !then
     /'(the first dummy omitted from the set)'
    !else !if (!macro='BUTLAST') !then
     /'(the last dummy omitted from the set)'
    !ifend !ifend .
-  end if.
-  do if val$$$$$._<>-999
     !if (!macro='BUTFIRST') !then and $casenum>1 !else !if (!macro='BUTLAST') !then and $casenum<nbn$$$$$._ !ifend !ifend.
-   print /' ' !quote(!conc(!var,!sep)) end$$$$$._$.
-  end if.
-  do if $casenum=1.
-   write outfile= 'temp_KO_acatbin_3.sps'
        /'define ' !quote(!conc('!',!var,!sep2)) '()'.
-  end if.
-  do if val$$$$$._<>-999
     !if (!macro='BUTFIRST') !then and $casenum>1 !else !if (!macro='BUTLAST') !then and $casenum<nbn$$$$$._ !ifend !ifend.
-   write outfile= 'temp_KO_acatbin_3.sps'
        /' ' !quote(!conc(!var,!sep)) end$$$$$._$.
-  end if.
-  do if $casenum=nbn$$$$$._.
-   write outfile= 'temp_KO_acatbin_3.sps'
        /'!enddefine.'.
-  end if.
  !ifend
- exec.
- insert file= 'temp_KO_acatbin_1.sps' syntax= batch.
- insert file= 'temp_KO_acatbin_2.sps' syntax= batch.
  !if (!macro<>'NONE' !and !macro<>!null) !then
-  insert file= 'temp_KO_acatbin_3.sps' syntax= batch.
  !ifend
  !do !del !in ('val$$$$$._ end$$$$$._ nbn$$$$$._ lstvar#$#$._ val$$$$$._$ end$$$$$._$ case#$#$._$')
-  del var !del.
  !doend
- dataset close dummy$$$$$._.
 !doend
-erase file 'temp_KO_acatbin_1.sps'.
-erase file 'temp_KO_acatbin_2.sps'.
 !if (!macro<>'NONE' !and !macro<>!null) !then
- erase file 'temp_KO_acatbin_3.sps'.
 !ifend
!ifend
!enddefine.

*/*!KO_ACATBIN2*/vers1***************************************************************************.
define !KO_acatbin2(dataset= !charend('/') /vars= !charend('/') /separ= !charend('/') /ending= !charend('/') /label= !charend('/')
                   /macro= !charend('/') /print= !charend('/'))
exec.
-echo ''.
-echo '**** CATEGORICAL INTO DUMMY (AUTO, !KO_ACATBIN2) ****'.
!let !sep= !unquote(!separ)
!if (!dataset=!null) !then
-echo ''.
-echo '>ERROR. Not specified DATASET.'.
-echo '>!KO_ACATBIN2 is not executed.'.
!else !if (!index(!sep,' ')>0) !then
-echo ''.
-echo '>ERROR. SEPAR cannot contain a blank.'.
-echo '>!KO_ACATBIN2 is not executed.'.
!else
 !if (!macro<>'NONE' !and !macro<>!null) !then
  !if (!macro='BUTFIRST') !then !let !doif= 'do if $casenum>1' !let !endif= 'end if'
  !else !let !doif= 'do if $casenum<tot$$$$$._' !let !endif= 'end if'
  !ifend
  !let !sep2= !sep
  !if (!sep2<>!null) !then !let !lensp2= !len(!sep2)
   !if (!index('._',!substr(!sep2,!lensp2))>0) !then !let !sep2= !head(!substr(!conc(' ',!sep2),1,!lensp2))
-   echo ''.
-   echo '>WARNING. SEPAR ends with "." or "_". When MACRO<>NONE, this'.
-   echo '>tail symbol is dropped from the macro name (name of a set of dummies).'.
   !ifend
  !ifend
  !if (!sep2<>!null) !then !let !lensp2= !len(!sep2)
   !if (!index('._',!substr(!sep2,!lensp2))>0) !then !let !sep2= !head(!substr(!conc(' ',!sep2),1,!lensp2)) !ifend
  !ifend
 !ifend
 !if (!dataset='RENAME') !then !let !dtst= 'KO_acatbin2#$._'
- dataset name KO_acatbin2#$._.
 !else !let !dtst= !dataset
 !ifend
-dataset activ !dtst.
-filter off.
-use all.
-split file off.
-weight off.
 !do !var !in (!vars) !let !cap= !quote(!conc(!var,!sep))
- dataset activ !dtst.
- temp.
- comp !var= trunc(!var).
- aggreg /out= * /break= !var /cnt$$$$$._= nu.
- format !var (f8).
- string val$$$$$._$ end$$$$$._$ (a8).
- select if not sysmis(!var).
- comp val$$$$$._$= rtrim(ltrim(string(!var,f8))).
  !if (!print='YES') !then
-  do if $casenum=1.
-   print /' ' /'----------'.
-  end if.
  !ifend
  !if (!ending='INDEX') !then
-  comp end$$$$$._$= rtrim(ltrim(string($casenum,f8))).
  !else
-  do if $casenum=1.
-   comp #negval1= !var<0.
-   do if #negval1.
-    print /' ' /!quote(!conc('>WARNING. Variable ',!var,' contains negative values.'))
           /'>!KO_ACATBIN2 will change specification ENDING=VALUE to ENDING=INDEX'
           /'>for this variable.'.
-    comp end$$$$$._$= '1'.
-   else.
-    comp end$$$$$._$= val$$$$$._$.
-   end if.
-  else.
-   do if #negval1.
-    comp end$$$$$._$= rtrim(ltrim(string($casenum,f8))).
-   else.
-    comp end$$$$$._$= val$$$$$._$.
-   end if.
-  end if.
  !ifend
  !if (!label='YES') !then
-  string lab$$$$$._$ (a123).
-  comp lab$$$$$._$= replace(valuelab(!var),"'","`").
-  comp lab$$$$$._$= conc(" '",rtrim(lab$$$$$._$),"'").
  !else
-  string lab$$$$$._$ (a10).
-  comp lab$$$$$._$= conc("'",rtrim(val$$$$$._$),"'").
  !ifend
- write outfile= 'temp_KO_acatbin2_1.sps'
       /'comp ' !cap end$$$$$._$ '= trunc(' !quote(!var) ')=' !var '.'
       /'format ' !cap end$$$$$._$ ' (f1)' '.' /'var lev ' !cap end$$$$$._$ ' (ord)' '.'.
- write outfile= 'temp_KO_acatbin2_1.sps'
       /'var lab ' !cap end$$$$$._$ lab$$$$$._$ '.'.
  !if (!print='YES') !then
-  do if $casenum=1.
-   print /' ' /!quote(!conc('Frequencies in variable ',!var,':')) /'   Value ' '  Count'.
-  end if.
-  print /!var cnt$$$$$._.
  !ifend
  !if (!macro<>'NONE' !and !macro<>!null) !then
-  aggr /out= * mode= addvari /tot$$$$$._= n.
-  do if $casenum=1.
-   write outfile= 'temp_KO_acatbin2_2.sps' /'define ' !quote(!conc('!',!var,!sep2)) '()'.
-   print /' ' /'!KO_ACATBIN2 has created the set of dummy variables as macro: ' !quote(!conc('!',!var,!sep2))
    !if (!macro='BUTFIRST') !then
     /'(the first dummy omitted from the set)'
    !else !if (!macro='BUTLAST') !then
     /'(the last dummy omitted from the set)'
    !ifend !ifend .
-  end if.
-  !doif.
-   write outfile= 'temp_KO_acatbin2_2.sps'
         /' ' !cap end$$$$$._$.
-   print /' ' !cap end$$$$$._$.
-  !endif.
-  do if $casenum=tot$$$$$._.
-   write outfile= 'temp_KO_acatbin2_2.sps' /'!enddefine.'.
-  end if.
  !ifend
- exec.
- dataset activ !dtst.
- insert file= 'temp_KO_acatbin2_1.sps'.
- exec.
  !if (!macro<>'NONE' !and !macro<>!null) !then
-  insert file= 'temp_KO_acatbin2_2.sps'.
  !ifend
 !doend
-erase file 'temp_KO_acatbin2_1.sps'.
 !if (!macro<>'NONE' !and !macro<>!null) !then
- erase file 'temp_KO_acatbin2_2.sps'.
 !ifend
!ifend !ifend
!enddefine.

*/*!KO_MRCMRD*/vers5***************************************************************************.
define !KO_mrcmrd(vars= !charend('/') /values= !charend('/') /dupl= !charend('/') /cap= !charend('/') /ending= !charend('/') /miss= !charend('/')
                 /noans= !charend('/') /label= !charend('/') /regist= !charend('/'))
exec.
-echo ''.
-echo '**** CATEGORICAL MR INTO DICHOTOMOUS MR ****'.
!let !ok= 1 !let !cp= !unquote(!cap) !let !novars= 1 !let !rt= 1
!if (!head(!dupl)='CREATE' !and (!tail(!dupl)=!null !or !tail(!dupl)=' 1')) !then !let !ok= 0
-echo ''.
-echo '>ERROR. After DUPL=CREATE there must go parameter, integer >1.'.
!else !if (!index(!values,'-')>0) !then !let !ok= 0
-echo ''.
-echo '>ERROR. VALUES cannot contain negative values.'.
!else !if (!index(!values,' EXCEPT')>0 !and !upcase(!head(!tail(!values)))<>'TO') !then !let !ok= 0
-echo ''.
-echo '>ERROR. VALUES has keyword EXCEPT, but TO on position two is missing.'.
!else !if (!index(!upcase(!vars),' TO ')>0 !and !tail(!tail(!tail(!vars)))<>!null) !then !let !ok= 0
-echo ''.
-echo '>ERROR. VARS can be specified either as list or via TO, but not mixed.'.
!else !if (!index(!cp,' ')>0) !then !let !ok= 0
-echo ''.
-echo '>ERROR. CAP cannot contain a blank.'.
!else !if (!dupl='COUNT' !and !head(!regist)='YES') !then !let !ok= 0
-echo ''.
-echo '>ERROR. DUPL=COUNT and REGIST=YES are incompatible.'.
!else !if (!head(!miss)='VAR' !and !tail(!miss)=!null) !then !let !ok= 0
-echo ''.
-echo '>ERROR. After MISS=VAR there must go variable name.'.
!else
 !if (!head(!dupl)='CREATE') !then !let !rt= !head(!tail(!dupl)) !ifend
 !if (!upcase(!head(!tail(!vars)))<>'TO') !then !let !vlist= !null
  !do !w !in (!vars) !let !vlist= !conc(!vlist,',',!w) !doend !let !vlist= !tail(!vlist)
 !else !let !vlist= !vars
 !ifend
 !if (!upcase(!head(!tail(!values)))='TO') !then !let !vals= !null
  !if (!head(!tail(!tail(!tail(!values))))='EXCEPT') !then !let !except= !tail(!tail(!tail(!tail(!values)))) !ifend
  !do !i= !head(!values) !to !head(!tail(!tail(!values)))
   !if (!index(!conc(!except,' '),!conc(' ',!i,' '))=0) !then !let !vals= !conc(!vals,' ',!i) !ifend
  !doend
 !else !let !vals= !values
  !do !w !in (!vals)
   !if (!index('.0123456789',!substr(!w,1,1))=0) !then !let !novars= 0 !break !ifend
  !doend
 !ifend
 !if (!tail(!vals)=!null) !then !let !ok= 0
- echo ''.
- echo '>ERROR. VALUES must make up at least two values.'.
 !else !if (!not !novars !and !rt>1) !then !let !ok= 0
- echo ''.
- echo '>ERROR. DUPL=CREATE n, but there are variable names in VALUES.'.
 !ifend !ifend
!ifend !ifend !ifend !ifend !ifend !ifend !ifend
!if (!ok) !then
 !if (!label='YES' !and !not !novars) !then
- echo ''.
- echo '>WARNING. LABEL=YES, but there are variable names in VALUES.'.
- echo '>!KO_MRCMRD will change the specification to LABEL=NO.'.
 !ifend
 !let !bvars= !null !let !qbvars= !null !let !bvars1= !null !let !bvarsrt= !null !let !cnt= !null
 !do !val !in (!vals) !let !cnt= !conc(!cnt,' ')
  !if (!ending='INDEX') !then !let !bvar= !conc(!cp,!len(!cnt))
    !else !let !bvar= !conc(!cp,!val)
  !ifend
  !if (!rt>1) !then
   !let !bvars= !conc(!bvars,' ',!bvar,#1,' to ',!bvar,#,!rt) !let !qbvars= !conc(!qbvars,' ',!quote(!conc(!bvar,#1)))
   !let !bvars1= !conc(!bvars1,' ',!bvar,#1) !let !bvarsrt= !conc(!bvarsrt,' ',!bvar,#,!rt)
  !else
   !let !bvars= !conc(!bvars,' ',!bvar) !let !qbvars= !conc(!qbvars,' ',!quote(!bvar))
  !ifend
 !doend
-numer !bvars !if (!dupl='COUNT') !then (f8) !else (f1) !ifend.
-var lev !bvars (ord).
-recode !bvars (else=0).
 !if (!rt>1) !then
- do rep val= !vals /bvar1= !bvars1 /bvarrt= !bvarsrt /#vec= #1 to !conc(#,!len(!cnt)).
-  count #cnt= !vars (val).
-  vector #vec= bvar1 to bvarrt.
-  loop #i= 1 to min(#cnt,!rt).
-   comp #vec(#i)= 1.
-  end loop.
- end rep.
 !else !if (!novars) !then
- do rep val= !vals /bvar= !bvars.
-  count bvar= !vars (val).
   !if (!dupl<>'COUNT') !then
-   comp bvar= bvar>0.
   !ifend
- end rep.
 !else !let !bvars2= !bvars
  !do !val !in (!vals) !let !bvar= !head(!bvars2) !let !bvars2= !tail(!bvars2)
-  do rep var= !vars.
-   comp !bvar= sum(!bvar,value(var)=!val).
-  end rep.
   !if (!dupl<>'COUNT') !then
-   comp !bvar= !bvar>0.
   !ifend
  !doend
 !ifend !ifend
 !if (!noans<>!null) !then !let !navar= !conc(!cp,!head(!noans))
- numer !navar (f1).
- var lev !navar (ord).
- comp !navar= sum(!head(!bvars) to !if (!rt>1) !then !conc(!bvar,#,!rt) !else !bvar !ifend)=0.
 !ifend
 !if (!miss<>!null !and !miss<>'NO') !then
  !if (!miss='SET') !then
-  do if nvalid(!vlist)=0.
  !else
-  do if miss(!tail(!miss)).
  !ifend
-   recode !bvars !navar (else=sysmis).
-  end if.
 !ifend
-exec.
 !if (!label='YES' !and !novars) !then !let !bylabs= 1 !else !let !bylabs= 0 !ifend
 !let !qvals= !null !let !vals2= !null
 !do !w !in (!vals) !let !qvals= !conc(!qvals,' ',!quote(!w)) !doend
 !if (!ending='INDEX') !then !let !cnt2= !null
  !do !w !in (!vals) !let !cnt2= !conc(!cnt2,' ') !let !vals2= !conc(!vals2,' ',!quote(!len(!cnt2))) !doend
 !else
  !let !vals2= !qvals
 !ifend
 !if (!bylabs) !then
- apply dict from= * /source var= !head(!vars) /target var= val$$$$$._ /newvar /varinfo vallab.
 !ifend
-string val$$$$$._$ (a180).
-do if $casenum=1.
- write outfile= 'temp_KO_mrcmrd.sps' /'var lab'.
- do rep val= !vals /qbvar= !qbvars /qval= !qvals.
   !if (!bylabs) !then
-   comp val$$$$$._= val.
-   comp val$$$$$._$= replace(valuelab(val$$$$$._),"'","`").
-   comp val$$$$$._$= conc(" ",qbvar," '",rtrim(val$$$$$._$),"'").
   !else
-   comp val$$$$$._$= conc(" ",qbvar," '",qval,"'").
   !ifend
-  write outfile= 'temp_KO_mrcmrd.sps' /val$$$$$._$.
- end rep.
-end if.
-exec.
-insert file= 'temp_KO_mrcmrd.sps' syntax= batch.
 !if (!noans<>!null) !then !let !nalab= !head(!tail(!noans))
- var lab !navar !if (!nalab=!null !or !nalab="''" !or !nalab='""') !then !quote(!head(!noans)) !else !nalab !ifend.
 !ifend
-delete vari !if (!bylabs) !then val$$$$$._ !ifend val$$$$$._$.
-erase file 'temp_KO_mrcmrd.sps'.
 !if (!head(!regist)='YES') !then
  !let !cp2= !cp !let !lencp2= !len(!cp2)
  !if (!index('._',!substr(!cp2,!lencp2))>0) !then !let !cp2= !substr(!substr(!conc(' ',!cp2),1,!lencp2),2)
-  echo ''.
-  echo '>WARNING. CAP ends with "." or "_". When REGIST=YES, this tail symbol'.
-  echo '>is dropped from the name of multiple response set being registered.'.
  !ifend
  !let !lencp2= !len(!cp2)
  !if (!index('._',!substr(!cp2,!lencp2))>0) !then !let !cp2= !substr(!substr(!conc(' ',!cp2),1,!lencp2),2) !ifend
  !if (!tail(!regist)<>!null) !then !let !setlab= !conc('label=',!tail(!regist)) !ifend
- mrset /mdgroup name= !conc('$',!cp2) !setlab vari= !bvars !navar value= 1
        /display name= [!conc('$',!cp2)].
 !ifend
!else
-echo '>!KO_MRCMRD is not executed.'.
!ifend
!enddefine.

*/*!KO_AMRCMRD*/vers1***************************************************************************.
define !KO_amrcmrd(vars= !charend('/') /sort= !charend('/') /dupl= !charend('/') /cap= !charend('/') /ending= !charend('/') /miss= !charend('/')
                  /noans= !charend('/') /label= !charend('/') /regist= !charend('/') /print= !charend('/'))
exec.
-echo ''.
-echo '**** CATEGORICAL MR INTO DICHOTOMOUS MR (AUTO, !KO_AMRCMRD) ****'.
!let !ok= 1 !let !cp= !unquote(!cap)
!if (!index(!upcase(!vars),' TO ')>0 !and !tail(!tail(!tail(!vars)))<>!null) !then !let !ok= 0
-echo ''.
-echo '>ERROR. VARS can be specified either as list or via TO, but not mixed.'.
!else !if (!index(!cp,' ')>0) !then !let !ok= 0
-echo ''.
-echo '>ERROR. CAP cannot contain a blank.'.
!else !if (!dupl='COUNT' !and !head(!regist)='YES') !then !let !ok= 0
-echo ''.
-echo '>ERROR. DUPL=COUNT and REGIST=YES are incompatible.'.
!else !if (!head(!miss)='VAR' !and !tail(!miss)=!null) !then !let !ok= 0
-echo ''.
-echo '>ERROR. After MISS=VAR there must go variable name.'.
!else
 !if (!upcase(!head(!tail(!vars)))<>'TO') !then !let !vlist= !null
  !do !w !in (!vars) !let !vlist= !conc(!vlist,',',!w) !doend !let !vlist= !tail(!vlist)
 !else !let !vlist= !vars
 !ifend
!ifend !ifend !ifend !ifend
!if (!ok) !then
-set mxloops 1E9.
-filter off.
-use all.
-split file off.
-weight off.
-dataset decl mrd$$$$$._ window= hidden.
-temp.
-do rep var= !vars.
- comp var= trunc(var).
-end rep.
-matrix.
-get vars /vari= !vars /miss= -999.
 !if (!ending<>'INDEX') !then
- comp ending= 1.
- do if any(vars<0 and vars<>-999).
-  print /title '>WARNING. Input variables contain negative values.'.
-  print /title '>!KO_AMRCMRD will change specification ENDING=VALUE to ENDING=INDEX.' /space= 0.
-  comp ending= 0.
- end if.
 !else
- comp ending= 0.
 !ifend
-comp n= nrow(vars).
-comp p= ncol(vars).
-comp bin= reshape(t(vars),n*p,1).
-comp des= design({-999;bin}).
-comp desm= des(2:nrow(des),1).
-comp des= des(2:nrow(des),2:ncol(des)).
-comp freq= csum(des).
-comp vals= bin*make(1,ncol(des),1)&*des.
-comp vals= cmax(vals)+cmin(vals).
-comp bin= des(1:n,:).
-comp nums= 1:n.
-loop i= 1 to p-1.
- comp bin= bin+des(nums+i*n,:).
-end loop.
-release des,vars.
 !if (!dupl<>'COUNT') !then
- comp bin= bin>0.
- comp freq= csum(bin).
 !ifend
 !if (!sort<>'NO') !then
- comp grd= grade(vals).
- comp bin(:,grd)= bin.
- comp freq(grd)= freq.
- comp vals(grd)= vals.
- release grd.
 !ifend
-comp freq= t(freq).
-comp vals= t(vals).
 !if (!print='YES') !then
- print {vals,freq}
    /title !if (!dupl='COUNT') !then 'Frequencies of responses in input MR set:' !else 'Frequencies of respondents in input MR set:' !ifend /clab= 'Value' 'Count'.
- print csum(freq) /title 'In sum:' /space= 0.
 !ifend
-do if nrow(vals)>1.
-do if nrow(vals)>1.
- do if ending.
-  comp ends= vals.
- else.
-  comp ends= t(1:nrow(vals)).
- end if.
- comp vals= {vals;-999}.
- comp ends= {ends;-999}.
- do if n>nrow(vals).
-  comp vals= {vals;make(n-nrow(vals),1,-999)}.
-  comp ends= {ends;make(n-nrow(ends),1,-999)}.
- else if n<nrow(vals).
-  comp bin= {bin;make(nrow(vals)-n,ncol(bin),-999)}.
- end if.
- save {vals,ends,bin(:,1)<>-999,bin} /out= mrd$$$$$._
     /vari= val$$$$$._ end$$$$$._ del$$$$$._ col$$$$$1 to col$$$$$10000.
-else.
- print /title '>ERROR. Input variables contain only one valid value.'.
- print /title '>!KO_AMRCMRD will not create binary variables, and error messages will follow.' /space= 0.
  !if (!noans<>!null) !then
-  print /title '>If "No answer" variable is created, delete it.' /space= 0.
  !ifend
-end if.
-end matrix.
-match files /file= * /file= mrd$$$$$._.
-comp lstvar#$#$._= 0.
-format col$$$$$1 to lstvar#$#$._ !if (!dupl='COUNT') !then (f8) !else (f1) !ifend.
-var lev col$$$$$1 to lstvar#$#$._ (ord).
 !if (!noans<>!null) !then !let !navar= !conc(!cp,!head(!noans)) !let !nalab= !head(!tail(!noans))
  !if (!miss='SET') !then
-  echo '>WARNING. NOANS is specified and MISS=SET (by default). In such conditions'.
-  echo '>"No answer" variable comes out zero.'.
  !ifend
- numer !navar (f1).
- var lev !navar (ord).
- var lab !navar !if (!nalab=!null !or !nalab="''" !or !nalab='""') !then !quote(!head(!noans)) !else !nalab !ifend.
- comp !navar= sum(col$$$$$1 to lstvar#$#$._)=0.
 !ifend
 !if (!miss<>!null !and !miss<>'NO') !then
  !if (!miss='SET') !then
-  do if nvalid(!vlist)=0.
  !else
-  do if miss(!tail(!miss)).
  !ifend
-   recode col$$$$$1 to lstvar#$#$._ !navar (else=sysmis).
-  end if.
 !ifend
-string end$$$$$._$ case#$#$._$ (a8).
-comp end$$$$$._$= ltrim(string(end$$$$$._,f8)).
-comp case#$#$._$= ltrim(string($casenum,f8)).
 !if (!label='YES') !then
- apply dict from= * /source var= !head(!vars) /target var= val$$$$$._ /varinfo vallab.
- string val$$$$$._$ (a123).
- comp val$$$$$._$= replace(valuelab(val$$$$$._),"'","`").
- comp val$$$$$._$= conc(" '",rtrim(val$$$$$._$),"'").
 !else
- string val$$$$$._$ (a10).
- comp val$$$$$._$= conc("'",rtrim(ltrim(string(val$$$$$._,f8))),"'").
 !ifend
 !if (!head(!regist)='YES') !then !let !reg= 1
  !let !cp2= !cp !let !lencp2= !len(!cp2)
  !if (!index('._',!substr(!cp2,!lencp2))>0) !then !let !cp2= !substr(!substr(!conc(' ',!cp2),1,!lencp2),2)
-  echo ''.
-  echo '>WARNING. CAP ends with "." or "_". When REGIST=YES, this tail symbol'.
-  echo '>is dropped from the name of multiple response set being registered.'.
  !ifend
  !let !lencp2= !len(!cp2)
  !if (!index('._',!substr(!cp2,!lencp2))>0) !then !let !cp2= !substr(!substr(!conc(' ',!cp2),1,!lencp2),2) !ifend
 !else !let !reg= 0
 !ifend
-do if $casenum=1.
- write outfile= 'temp_KO_amrcmrd_1.sps'
       /'rename vari'.
-end if.
-do if val$$$$$._<>-999.
- write outfile= 'temp_KO_amrcmrd_1.sps'
       /' (col$$$$$' case#$#$._$ '=' !quote(!cp) end$$$$$._$ ')'.
-end if.
-do if $casenum=1.
- write outfile= 'temp_KO_amrcmrd_2.sps'
       /'var lab'.
-end if.
-do if val$$$$$._<>-999.
- write outfile= 'temp_KO_amrcmrd_2.sps'
       /' ' !quote(!cp) end$$$$$._$ val$$$$$._$.
-end if.
 !if (!reg) !then
  !if (!tail(!regist)<>!null) !then !let !setlab= !conc('label=',!tail(!regist)) !ifend
- do if $casenum=1.
-  write outfile= 'temp_KO_amrcmrd_3.sps'
       /'mrset /mdgroup name=' !quote(!conc('$',!cp2,' ',!setlab)) ' vari='.
- end if.
- do if val$$$$$._<>-999.
-  write outfile= 'temp_KO_amrcmrd_3.sps'
       /' ' !quote(!cp) end$$$$$._$.
- end if.
- do if val$$$$$._=-999 and lag(val$$$$$._)<>-999.
-  write outfile= 'temp_KO_amrcmrd_3.sps'
       /' ' !quote(!navar) ' value=1 /display name=[' !quote(!conc('$',!cp2,']')).
- end if.
 !ifend
-exec.
-insert file= 'temp_KO_amrcmrd_1.sps' syntax= batch.
-insert file= 'temp_KO_amrcmrd_2.sps' syntax= batch.
 !if (!reg) !then
- insert file= 'temp_KO_amrcmrd_3.sps' syntax= batch.
 !ifend
-select if del$$$$$._.
-exec.
-del vari val$$$$$._ end$$$$$._ del$$$$$._.
-del vari lstvar#$#$._ val$$$$$._$ end$$$$$._$ case#$#$._$.
-dataset close mrd$$$$$._.
-erase file 'temp_KO_amrcmrd_1.sps'.
-erase file 'temp_KO_amrcmrd_2.sps'.
 !if (!reg) !then
- erase file 'temp_KO_amrcmrd_3.sps'.
 !ifend
!else
-echo '>!KO_AMRCMRD is not executed.'.
!ifend
!enddefine.

*/*!KO_AMRCMRD2*/vers1***************************************************************************.
define !KO_amrcmrd2(dataset= !charend('/') /vars= !charend('/') /dupl= !charend('/') /cap= !charend('/') /ending= !charend('/') /miss= !charend('/')
                  /noans= !charend('/') /label= !charend('/') /regist= !charend('/') /print= !charend('/'))
exec.
-echo ''.
-echo '**** CATEGORICAL MR INTO DICHOTOMOUS MR (AUTO, !KO_AMRCMRD2) ****'.
!let !ok= 1 !let !cp= !quote(!unquote(!cap))
!if (!dataset=!null) !then !let !ok= 0
-echo ''.
-echo '>ERROR. Not specified DATASET.'.
!else !if (!index(!upcase(!vars),' TO ')>0 !and !tail(!tail(!tail(!vars)))<>!null) !then !let !ok= 0
-echo ''.
-echo '>ERROR. VARS can be specified either as list or via TO, but not mixed.'.
!else !if (!index(!cp,' ')>0) !then !let !ok= 0
-echo ''.
-echo '>ERROR. CAP cannot contain a blank.'.
!else !if (!dupl='COUNT' !and !head(!regist)='YES') !then !let !ok= 0
-echo ''.
-echo '>ERROR. DUPL=COUNT and REGIST=YES are incompatible.'.
!else !if (!head(!miss)='VAR' !and !tail(!miss)=!null) !then !let !ok= 0
-echo ''.
-echo '>ERROR. After MISS=VAR there must go variable name.'.
!else
 !if (!upcase(!head(!tail(!vars)))<>'TO') !then !let !vlist= !null
  !do !w !in (!vars) !let !vlist= !conc(!vlist,',',!w) !doend !let !vlist= !tail(!vlist)
 !else !let !vlist= !vars
 !ifend
!ifend !ifend !ifend !ifend !ifend
!if (!ok) !then
 !let !reg= 0 !let !towarn= 0
 !if (!head(!regist)='YES') !then !let !reg= 1
  !let !cp2= !unquote(!cp) !let !lencp2= !len(!cp2)
  !if (!index('._',!substr(!cp2,!lencp2))>0) !then !let !cp2= !substr(!substr(!conc(' ',!cp2),1,!lencp2),2) !let !towarn= 1 !ifend
  !let !lencp2= !len(!cp2)
  !if (!index('._',!substr(!cp2,!lencp2))>0) !then !let !cp2= !substr(!substr(!conc(' ',!cp2),1,!lencp2),2) !ifend
 !ifend
 !if (!dataset='RENAME') !then !let !dtst= 'KO_amrcmrd2#$._'
- dataset name KO_amrcmrd2#$._.
 !else !let !dtst= !dataset
 !ifend
-dataset activ !dtst.
-filter off.
-use all.
-split file off.
-weight off.
 !if (!miss='SET') !then
- comp novld$$$$$._= nvalid(!vlist)=0.
 !else !if (!head(!miss)='VAR') !then
- comp novld$$$$$._= miss(!tail(!miss)).
 !ifend !ifend
-dataset copy restr#$#$ window= hidden.
-dataset activ restr#$#$.
-do rep var= !vars.
- comp var= trunc(var).
-end rep.
-set results none errors none.
-varstocas /make res$$$$$._ from !vars
  /id= id$$$$$._ /keep= /null= drop.
-set results list errors list.
-miss val res$$$$$._ ().
 !if (!print='YES' !and !dupl<>'COUNT') !then !let !resp= 'of respondents'
- sort cases by id$$$$$._ res$$$$$._.
- match files /file= * /by id$$$$$._ res$$$$$._ /first= fst$$$$$._.
- select if fst$$$$$._.
- exec.
 !else !let !resp= 'of responses'
 !ifend
-aggreg /out= * /break= res$$$$$._ /cnt$$$$$._= nu.
-aggreg /out= * mode= addvari /ncat$$$$$._= nu /nres$$$$$._= sum(cnt$$$$$._).
-format res$$$$$._ nres$$$$$._ (f8).
-string val$$$$$._$ end$$$$$._$ (a8).
-comp val$$$$$._$= rtrim(ltrim(string(res$$$$$._,f8))).
 !if (!ending='INDEX') !then
- comp end$$$$$._$= rtrim(ltrim(string($casenum,f8))).
 !else
- do if $casenum=1.
-  comp #negval1= res$$$$$._<0.
-  do if #negval1.
-   print /' ' /'>WARNING. Input variables contain negative values.'
          /'>!KO_AMRCMRD2 will change specification ENDING=VALUE to ENDING=INDEX.'.
-   comp end$$$$$._$= '1'.
-  else.
-   comp end$$$$$._$= val$$$$$._$.
-  end if.
- else.
-  do if #negval1.
-   comp end$$$$$._$= rtrim(ltrim(string($casenum,f8))).
-  else.
-   comp end$$$$$._$= val$$$$$._$.
-  end if.
- end if.
 !ifend
 !if (!label='YES') !then
- string lab$$$$$._$ (a123).
- comp lab$$$$$._$= replace(valuelab(res$$$$$._),"'","`").
- comp lab$$$$$._$= conc(" '",rtrim(lab$$$$$._$),"'").
 !else
- string lab$$$$$._$ (a10).
- comp lab$$$$$._$= conc("'",rtrim(val$$$$$._$),"'").
 !ifend
-write outfile= 'temp_KO_amrcmrd2_1.sps'
      /'comp ' !cp end$$$$$._$ '= 0'
      /'do rep var= '
     !do !w !in (!vars) 
      /' ' !quote(!w)
     !doend
      /'if not sysmis(trunc(var)) ' !cp end$$$$$._$ '= ' !cp end$$$$$._$ '+(trunc(var)=' res$$$$$._ ')'
      /'end rep'
     !if (!dupl<>'COUNT') !then
      /'comp ' !cp end$$$$$._$ '= ' !cp end$$$$$._$ '>0'
     !ifend
     !if (!miss<>!null !and !miss<>'NO') !then
      /'if novld$$$$$._ ' !cp end$$$$$._$ '= $sysmis'
     !ifend
      /'format ' !cp end$$$$$._$ !if (!dupl='COUNT') !then '(f8)' !else '(f1)' !ifend
      /'var lev ' !cp end$$$$$._$ ' (ord)'
      /'var lab ' !cp end$$$$$._$ lab$$$$$._$.
 !if (!print='YES') !then
- do if $casenum=1.
-  print /' ' /'Frequencies ' !quote(!resp) ' in input MR set:' /'   Value ' '  Count'.
- end if.
- print /res$$$$$._ cnt$$$$$._.
- do if $casenum=ncat$$$$$._.
-  print /'In sum: ' nres$$$$$._.
- end if.
 !ifend
 !if (!noans<>!null) !then !let !navar= !quote(!conc(!unquote(!cp),!head(!noans))) !let !nalab= !head(!tail(!noans))
  !if (!nalab=!null !or !nalab="''" !or !nalab='""') !then !let !nalab= !quote(!head(!noans)) !ifend
- string #end1 (a8).
- do if $casenum=1.
-  comp #end1= end$$$$$._$.
- end if.
- do if $casenum=ncat$$$$$._.
-  write outfile= 'temp_KO_amrcmrd2_1.sps'
        /'comp ' !navar '= sum(' !cp #end1 ' to ' !cp end$$$$$._$ ')=0'
        /'format ' !navar ' (f1)'
        /'var lev ' !navar ' (ord)'
        /'var lab ' !navar !quote(!nalab).
- end if.
 !ifend
 !if (!reg) !then
  !if (!tail(!regist)<>!null) !then !let !setlab= !conc('label=',!tail(!regist)) !ifend
- do if $casenum=1.
-  write outfile= 'temp_KO_amrcmrd2_2.sps'
       /'mrset /mdgroup name=' !quote(!conc('$',!cp2,' ',!setlab)) ' vari='.
- end if.
- write outfile= 'temp_KO_amrcmrd2_2.sps'
       /' ' !cp end$$$$$._$.
- do if $casenum=ncat$$$$$._.
-  write outfile= 'temp_KO_amrcmrd2_2.sps'
       /' ' !navar ' value=1 /display name=[' !quote(!conc('$',!cp2,']')).
- end if.
 !ifend
-exec.
-dataset close restr#$#$.
-dataset activ !dtst.
 !if (!noans<>!null !and !miss='SET') !then
- echo ''.
- echo '>WARNING. NOANS is specified and MISS=SET (by default). In such conditions'.
- echo '>"No answer" variable comes out zero.'.
 !ifend
 !if (!towarn) !then
- echo ''.
- echo '>WARNING. CAP ends with "." or "_". When REGIST=YES, this tail symbol'.
- echo '>is dropped from the name of multiple response set being registered.'.
 !ifend
-insert file= 'temp_KO_amrcmrd2_1.sps' syntax= batch.
-exec.
 !if (!reg) !then
- insert file= 'temp_KO_amrcmrd2_2.sps' syntax= batch.
 !ifend
 !if (!miss<>!null !and !miss<>'NO') !then
- del var novld$$$$$._.
 !ifend
-erase file 'temp_KO_amrcmrd2_1.sps'.
 !if (!reg) !then
- erase file 'temp_KO_amrcmrd2_2.sps'.
 !ifend
!else
-echo '>!KO_AMRCMRD2 is not executed.'.
!ifend
!enddefine.

*/*!KO_MRDMRC*/vers4***************************************************************************.
define !KO_mrdmrc(vars= !charend('/') /selval= !charend('/') /codes= !charend('/') /limit= !charend('/') /cap= !charend('/')
                 /noans= !charend('/') /filler= !charend('/') /miss= !charend('/') /label= !charend('/')
                 /regist= !charend('/') /dropind= !charend('/'))
exec.
-echo ''.
-echo '**** DICHOTOMOUS MR INTO CATEGORICAL MR ****'.
!let !ok= 1 !let !cp= !unquote(!cap) !let !ar= 'any' !let !nacode= !head(!noans)
!if (!tail(!vars)=!null) !then !let !ok= 0
-echo ''.
-echo '>ERROR. VARS must consist of at least two variables.'.
!else !if (!index(!upcase(!vars),' TO ')>0) !then !let !ok= 0
-echo ''.
-echo '>ERROR. VARS must be name-by-name list.'.
!else !if (!index(!conc(!codes,!nacode),'-')>0) !then !let !ok= 0
-echo ''.
-echo '>ERROR. CODES and NOANS cannot have negative values.'.
!else !if (!head(!selval)='COUNT' !and !tail(!selval)=!null) !then !let !ok= 0
-echo ''.
-echo '>ERROR. After SELVAL=COUNT there must go parameter (integer>0).'.
!else !if (!index(!cp,' ')>0) !then !let !ok= 0
-echo ''.
-echo '>ERROR. CAP cannot contain a blank.'.
!else !if (!head(!miss)='VAR' !and !tail(!miss)=!null) !then !let !ok= 0
-echo ''.
-echo '>ERROR. After MISS=VAR there must go variable name.'.
!else
 !if (!selval=!null) !then !let !slvl= ',1'
 !else !if (!head(!selval)<>'COUNT') !then
  !if (!upcase(!head(!tail(!selval)))='THRU') !then !let !ar= 'range' !let !slvl= !conc(',',!head(!selval),',',!tail(!tail(!selval)))
  !else !let !slvl= !null
   !do !w !in (!selval) !let !slvl= !conc(!slvl,',',!w) !doend
  !ifend
 !ifend !ifend
 !let !cods= !null !let !vlist= !null !let !vrs= !vars !let !cds= !codes
 !do !k= 1 !to 999
  !let !vlist= !conc(!vlist,',',!head(!vrs))
  !if (!codes=!null !or !codes='ORDINAL') !then !let !cods= !conc(!cods,' ',!k)
  !else
   !if (!codes='EXTRACT') !then !let !var= !head(!vrs) !let !code= !null
    !do !i= !len(!var) !to 2 !by -1
     !if (!index('0123456789',!substr(!var,!i,1))>0) !then !let !code= !substr(!var,!i) !else !break !ifend
    !doend
    !if (!code<>!null) !then !let !cods= !conc(!cods,' ',!code)
    !else !let !ok= 0
-    echo ''.
-    echo '>ERROR. With CODES=EXTRACT names in VARS must end with a number.'.
     !break
    !ifend
   !else
    !if (!cds=!null) !then !break !ifend
    !let !cods= !conc(!cods,' ',!head(!cds)) !let !cds= !tail(!cds)
   !ifend
  !ifend
  !let !vrs= !tail(!vrs)
  !if (!vrs=!null) !then !break !ifend
 !doend
 !if (!codes<>!null !and !codes<>'ORDINAL' !and !codes<>'EXTRACT') !then
  !if (!vrs<>!cds) !then !let !ok= 0
-  echo ''.
-  echo '>ERROR. Lists VARS and CODES are of different length.'.
  !ifend   
 !ifend
 !if (!filler<>!null !and !index(!conc(!cods,' '),!conc(' ',!filler,' '))>0) !then !let !ok= 0
- echo ''.
- echo '>ERROR. Code FILLER coincides with one of the codes specified in CODES.'.
 !ifend
!ifend !ifend !ifend !ifend !ifend !ifend
!if (!ok) !then
 !if (!head(!regist)='YES' !or !dropind='YES') !then
  !let !cp2= !cp !let !lencp2= !len(!cp2) !let !towarn= 0
  !if (!index('._',!substr(!cp2,!lencp2))>0) !then !let !cp2= !substr(!substr(!conc(' ',!cp2),1,!lencp2),2)
   !let !towarn= 1
  !ifend
  !let !lencp2= !len(!cp2)
  !if (!index('._',!substr(!cp2,!lencp2))>0) !then !let !cp2= !substr(!substr(!conc(' ',!cp2),1,!lencp2),2) !ifend
 !ifend
 !if (!limit>0 !and !limit<999) !then !let !lim= !limit
 !else !let !lim= !k
  !if (!head(!selval)='COUNT') !then !let !lim= !null
   !do !cnt= 1 !to !tail(!selval)
    !do !i= 1 !to !k !let !lim= !conc(!lim,' ') !doend
   !doend !let !lim= !len(!lim)
  !ifend
 !ifend
 !let !cvars= !conc(!cp,1,' to ',!cp,!lim)
 !if (!index(!conc(!codes,!nacode,!filler),'.')=0) !then !let !f= '(f8)' !ifend
-numer !conc(!cp,1) !if (!lim>1) !then to !conc(!cp,!lim) !ifend !f.
 !if (!filler<>!null) !then
- recode !cvars (else=!filler).
- miss val !conc(!cp,1) !if (!lim>1) !then to !conc(!cp,!lim) !ifend (!filler).
 !ifend
-vector mrc= !cvars.
-comp #s= 1.
-do rep var= !vars /code= !cods.
  !if (!slvl=!null) !then
-  do if trunc(var)>0.
-   comp #n= min(trunc(var),!head(!tail(!selval))).
-   loop #i= #s to min(#s+#n-1,!lim).
-    comp mrc(#i)= code.
-   end loop.
-   comp #s= #s+#n.
-  end if.
  !else
-  do if !ar(var !slvl) and #s<=!lim.
-   comp mrc(#s)= code.
-   comp #s= #s+1.
-  end if.
  !ifend
-end rep.
 !if (!noans<>!null) !then
- recode !conc(!cp,1) (missing=!nacode).
 !ifend
 !if (!miss<>'NO' !and !miss<>!null) !then
  !if (!miss='SET') !then
-  do if nvalid(!tail(!vlist))=0.
  !else
-  do if miss(!tail(!miss)).
  !ifend
-   recode !cvars (else=sysmis).
-  end if.
 !ifend
-exec.
 !if (!filler<>!null !and !filler=!nacode) !then
- miss val !conc(!cp,1) ().
- echo ''.
- echo '>WARNING. Code NOANS coincides with FILLER.'.
- echo '>!KO_MRDMRC will not give it missing status in the 1st variable of the MRC set.'.
 !ifend
-var lev !cvars (nom).
 !if (!tail(!regist)<>!null) !then !let !setlab= !conc('label=',!tail(!regist))
- var lab !conc(!cp,1) !tail(!regist).
 !ifend
 !let !drpnd= 0
 !if (!limit='MIN' !or !limit=!null) !then
  !if (!dropind='YES') !then !let !drpnd= 1 !ifend
- aggreg /out= * mode= addvari
    /sm$$$$$2 !if (!lim<>2) !then to !conc('sm$$$$$',!lim) !ifend = min(!conc(!cp,2) to !conc(!cp,!lim)).
- do if $casenum=1.
-  write outfile= 'temp_KO_mrdmrc_1.sps'
       /'del vari sm$$$$$2 to ' !quote(!conc('sm$$$$$',!lim)).
-  write outfile= 'temp_KO_mrdmrc_2.sps'
       /'mrset /mcgroup name= ' !quote(!conc('$',!cp2)) ' ' !quote(!setlab) ' ' !quote(!conc('vari= ',!cp,1)). 
   !if (!drpnd) !then
-   write outfile= 'temp_KO_mrdmrc_4.sps' /'.'.
   !ifend
   !do !i= 2 !to !lim
-   do if sysmis(!conc('sm$$$$$',!i)).
-    write outfile= 'temp_KO_mrdmrc_1.sps' /' ' !quote(!conc(!cp,!i)).
     !if (!drpnd !and !i=2) !then
-     write outfile= 'temp_KO_mrdmrc_4.sps'
          /"echo ''"
          /'echo ' !quote(!quote('>WARNING. Because DROPIND=YES and single variable came out, its name will'))
          /'echo ' !quote(!quote('>lose index "1" (and also tail "." or "_", if CAP ends with them).'))
          /'rename var (' !quote(!conc(!cp,1,'=',!cp2)) ')'.
     !ifend
-   else.
-    write outfile= 'temp_KO_mrdmrc_2.sps' /' ' !quote(!conc(!cp,!i)).
-   end if.
   !doend
- end if.
- exec.
- insert file= 'temp_KO_mrdmrc_1.sps' syntax= batch.
- exec.
 !ifend
 !if (!label='YES') !then !let !vars2= !null
  !do !var !in (!vars) !let !vars2= !conc(!vars2,'+',!var) !doend
- dataset decl label$$$$$._ window= hidden.
- comp z0$$$$$._= 1.
- OMS /SELECT TABLES /IF COMMANDS=['CTables'] SUBTYPES=['Custom Table']
    /DESTINATION FORMAT=SAV OUTFILE='label$$$$$._' VIEWER=NO.
- OMS /DESTINATION VIEWER=NO.
- temp.
- split file off.
- filter off.
- weight off.
- select if $casenum=1.
- do rep var= !vars /code= !cods.
-  comp var= code.
- end rep.
- ctable /vlab vari= all display= label /table (!tail(!vars2)) [s] [maximum].
- OMSEND.
- match files file= * /file= label$$$$$._
    /rename (all = z1$$$$$._ z2$$$$$._ z3$$$$$._ z4$$$$$._ z5$$$$$._).
- set results none errors none.
- alter type z4$$$$$._ (a122) /print none.
- set results list errors list.
- do if not sysmis(z5$$$$$._).
   !do !var !in (!vars)
-   if upcase(z4$$$$$._)=!quote(!upcase(!var)) or z4$$$$$._=' ' z5$$$$$._= $sysmis.
   !doend
-  comp z4$$$$$._= replace(z4$$$$$._,"'","`").
-  comp z4$$$$$._= concat("'",rtrim(z4$$$$$._),"'").
- end if.
- dataset close label$$$$$._.
- do if $casenum=1.
-  write outfile= 'temp_KO_mrdmrc_3.sps'
        /'val lab ' !quote(!conc(!cp,1)).
- end if.
- do if not sysmis(z5$$$$$._).
-  write outfile= 'temp_KO_mrdmrc_3.sps'
        /' ' z5$$$$$._ ' ' z4$$$$$._.
- end if.
- select if z0$$$$$._=1.
- exec.
- insert file= 'temp_KO_mrdmrc_3.sps' syntax= batch.
- del vari z0$$$$$._ z1$$$$$._ z2$$$$$._ z3$$$$$._ z4$$$$$._ z5$$$$$._.
- erase file= 'temp_KO_mrdmrc_3.sps'.
  !if (!noans<>!null) !then !let !nalab= !head(!tail(!noans))
   !if (!nalab<>!null !and !nalab<>"''" !and !nalab<>'""') !then
-   add val lab !conc(!cp,1) !nacode !nalab.
   !ifend
  !ifend
 !ifend
 !if (!head(!regist)='YES') !then
  !if (!towarn) !then
-  echo ''.
-  echo '>WARNING. CAP ends with "." or "_". When REGIST=YES, this tail symbol'.
-  echo '>is dropped from the name of multiple response set being registered.'.
  !ifend
  !if (!limit=!null !or !limit='MIN') !then
-  insert file= 'temp_KO_mrdmrc_2.sps' syntax= batch.
  !else
-  mrset /mcgroup name= !conc('$',!cp2) !setlab vari= !cvars.
  !ifend
- mrset /display name= [!conc('$',!cp2)].
 !ifend
 !if (!drpnd) !then
- insert file= 'temp_KO_mrdmrc_4.sps' syntax= batch.
- erase file= 'temp_KO_mrdmrc_4.sps'.
 !ifend
 !if (!limit=!null !or !limit='MIN') !then
- erase file= 'temp_KO_mrdmrc_1.sps'.
- erase file= 'temp_KO_mrdmrc_2.sps'.
 !ifend
!else
-echo '>!KO_MRDMRC is not executed.'.
!ifend
!enddefine.
